//
import SD.RD;
import SGF.GamePiece;
import mx.transitions.Tween;
import mx.transitions.easing.*;

//Can extend GamePiece or GameCollisionPiece
class GamePlay2.GamePlay2MC extends GamePiece{
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	//Private vars
	
	//private var s:String;
	
	
	//Sub MC Vars
	
	private var gfxLines:MovieClip;
	private var txtIntro:MovieClip;
	private var btnNext:MovieClip;
	private var btnNextText:MovieClip;
	private var f1:MovieClip;
	private var f2:MovieClip;
	private var f3:MovieClip;
	private var f4:MovieClip;
	private var f5:MovieClip;
	
	private var circlePos:Array;
	
	
	//Sub MC Buttons
	
	//private var b:Button;
	
	
	//Sub TextField vars
	
	//private var t:TextField;
	
	
	//Components
	
	
	
	
	//************************************************************
	//PUBLIC VARS
	//************************************************************
	
	//Public vars
	
	
	
	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function GamePlay2MC(){
		
		//RD.D("GameController Created", this);
		__linkageName = "GamePlay2MC";
		//makeThisADispatcher();
		//dispatchMyEvent("e_someEvent", {myMessage:"none"});
		//
		//v_setup();
		setupBtns();
				
		
	}
		
	
	
	private function setupBtns(){
		
		btnNext.onRelease = function(){
			
			this._parent.getRef().sceneDirector.playScene("scene3");
			
		}
	}
		
	
		
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	
	//************************************************************
	//INITIAL FUNCTIONS: Usually functions off the constructor
	//************************************************************
	//this overides the scene director function which is called when a new scene containing this MC is loaded
	private function playScene(){
		
		showGamePiece();
		v_setup();
		v_show();
		
		_level0.jdgSoundHandMC.loadQueuedSound();
		
	}
	
	//this is called when the scene that this GamePiece is in is removed
	//Note when you call this you have to handle the removal of the GamePiece yourself
	//private function removeScene(){
		
		
	//}
	
	
	//using this function overrides the general hide scene hideGamePiece() function
	//so make sure you hide the GamePiece after running this function
	/*private function removeScene(){
		
		
	}*/
	
	
	private function initiate(){
		
		
	}
	
	//************************************************************
	//PUBLIC VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	//************************************************************
	//PRIVATE VISUAL FUNCTIONS: Functions that hide and show items in the MC
	//************************************************************
	
	//************************************************************
	//PUBLIC VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	public function enable(){
		
		
	}
	
	public function disable(){
		
		
	}

	//************************************************************
	//PRIVATE VISUAL STRUCTURAL FUNCTIONS: Functions that affect the visuals and structure of the MC 
	//************************************************************
	
	private function v_setup(){
		
		circlePos = [{x:f1._x, y:f1._y}, {x:f2._x, y:f2._y}, {x:f3._x, y:f3._y}, {x:f4._x, y:f4._y}, {x:f5._x, y:f5._y}];
		
		for(var x = 1; x < 6; x++){
			
			eval(this + ".f" + x)._alpha = 0;
			
		}
		
		gfxLines._alpha = 0;
		txtIntro._alpha = 0;
		btnNext._alpha = 0;
		btnNext.enabled = false;
		btnNextText._alpha = 0;
		
		f1._x = circlePos[0].x + 120;
		f1._y = circlePos[0].y - 40;
		
		f2._x = circlePos[1].x - 120;
		f2._y = circlePos[1].y - 40;
		
		f3._x = circlePos[2].x + 120;
		f3._y = circlePos[2].y - 40;
		
		f4._x = circlePos[3].x - 120;
		f4._y = circlePos[3].y - 40;
		
		f5._x = circlePos[4].x + 120;
		f5._y = circlePos[4].y - 40;
		
	}
	
	//#1
	private function v_show(){
		
		var myTween:Object = new Tween(f1, "_alpha", Regular.easeOut, 0, 100, .3, true);
		var myTween1:Object = new Tween(f1, "_x", Regular.easeOut, f1._x, circlePos[0].x, .4, true);
		//Macromedia tween class call
		var myTween2:Object = new Tween(f1, "_y", Regular.easeOut, f1._y, circlePos[0].y, .4, true);
		myTween2.callingMC = this;
		myTween2.onMotionFinished = function() {
			
			delete myTween2.onMotionFinished;//this stops the function calling back itself if you retween
			myTween2.callingMC.v_show1();
				
		};
	}
	
	//#2
	private function v_show1(){
		
		var myTween:Object = new Tween(f2, "_alpha", Regular.easeOut, 0, 100, .3, true);
		var myTween1:Object = new Tween(f2, "_x", Regular.easeOut, f2._x, circlePos[1].x, .4, true);
		//Macromedia tween class call
		var myTween2:Object = new Tween(f2, "_y", Regular.easeOut, f2._y, circlePos[1].y, .4, true);
		myTween2.callingMC = this;
		myTween2.onMotionFinished = function() {
			
			delete myTween2.onMotionFinished;//this stops the function calling back itself if you retween
			myTween2.callingMC.v_show2();
				
		};
	}
	
	
	//#3
	private function v_show2(){
		
		var myTween:Object = new Tween(f3, "_alpha", Regular.easeOut, 0, 100, .3, true);
		var myTween1:Object = new Tween(f3, "_x", Regular.easeOut, f3._x, circlePos[2].x, .4, true);
		//Macromedia tween class call
		var myTween2:Object = new Tween(f3, "_y", Regular.easeOut, f3._y, circlePos[2].y, .4, true);
		myTween2.callingMC = this;
		myTween2.onMotionFinished = function() {
			
			delete myTween2.onMotionFinished;//this stops the function calling back itself if you retween
			myTween2.callingMC.v_show3();
				
		};
	}
	
	
	//#4
	private function v_show3(){
		
		var myTween:Object = new Tween(f4, "_alpha", Regular.easeOut, 0, 100, .3, true);
		var myTween1:Object = new Tween(f4, "_x", Regular.easeOut, f4._x, circlePos[3].x, .4, true);
		//Macromedia tween class call
		var myTween2:Object = new Tween(f4, "_y", Regular.easeOut, f4._y, circlePos[3].y, .4, true);
		myTween2.callingMC = this;
		myTween2.onMotionFinished = function() {
			
			delete myTween2.onMotionFinished;//this stops the function calling back itself if you retween
			myTween2.callingMC.v_show4();
				
		};
	}
	
	
	//#5
	private function v_show4(){
		
		var myTween:Object = new Tween(f5, "_alpha", Regular.easeOut, 0, 100, .3, true);
		var myTween1:Object = new Tween(f5, "_x", Regular.easeOut, f5._x, circlePos[4].x, .4, true);
		//Macromedia tween class call
		var myTween2:Object = new Tween(f5, "_y", Regular.easeOut, f5._y, circlePos[4].y, .4, true);
		myTween2.callingMC = this;
		myTween2.onMotionFinished = function() {
			
			delete myTween2.onMotionFinished;//this stops the function calling back itself if you retween
			myTween2.callingMC.v_show5();
				
		};
	}
	
	
	//#6
	private function v_show5(){
		
		var myTween:Object = new Tween(gfxLines, "_alpha", Regular.easeOut, 0, 100, .5, true);
		var myTween1:Object = new Tween(txtIntro, "_alpha", Regular.easeOut, 0, 100, .5, true);
		var myTween2:Object = new Tween(btnNext, "_alpha", Regular.easeOut, 0, 100, .5, true);
		var myTween3:Object = new Tween(btnNextText, "_alpha", Regular.easeOut, 0, 100, .5, true);
		btnNext.enabled = true;
		
	}
	
	//************************************************************
	//PUBLIC CHARACTER FUNCTIONS: Functions that animate characters
	//************************************************************
	
	//************************************************************
	//PUBLIC CHARACTER SCRIPT FUNCTIONS: Functions called from outside which execute character animation scripts
	//************************************************************
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	//************************************************************
	//PRIVATE HELPER FUNCTIONS
	//************************************************************

	//____EVENTS_________________________________________________

	//************************************************************
	//REGULAR EVENT FUNCTIONS: Functions that fire off regular MC events like private function onRelease(){}
	//************************************************************

	//************************************************************
	//CUSTOM EVENT FUNCTIONS: Functions that fire off custom made dispatched events
	//************************************************************
	
	//************************************************************
	//CUSTOM LOCAL EVENT FUNCTIONS: Functions that fire off events written into the fla of a MC like _parent.e_fireMyFunction();
	//************************************************************
	
	//************************************************************
	//SUB MCs THAT FIRE FUNCTIONS: Functions that are called from .as files child MovieClips
	//************************************************************
	

}